#ifndef _IOCTLCMD_H
#define _IOCTLCMD_H


/* The actual name of the TraceHook's device driver
 */
const CHAR DriverFileName[] = "TraceHook.sys";

/* The HDD pathes of where the malware process dumps are going
 * to be stored in.
 */
const CHAR KernelDumpPath[] = "\\Device\\HardDiskVolume1\\dump";
const CHAR UserDumpPath[]   = "C:\\dump";

/* The symbolic filenames used by the user-mode client application
 * to communicate with the kernel module
 */
const WCHAR DriverName[]    = L"\\Device\\TraceHook";
const WCHAR DosDeviceName[] = L"\\DosDevices\\TraceHook";


/* 
 * The IOCTL message definitions (both constant identifiers and handler functions
 */
#define IOCTL_QUERY_VERSION \
CTL_CODE(FILE_DEVICE_UNKNOWN, 0x880, METHOD_BUFFERED, FILE_READ_DATA)
#define IOCTL_FINISH \
CTL_CODE(FILE_DEVICE_UNKNOWN, 0x884, METHOD_BUFFERED , FILE_READ_DATA)

#define IOCTL_ADD_PROCESS \
CTL_CODE(FILE_DEVICE_UNKNOWN, 0x881, METHOD_NEITHER , FILE_READ_DATA)
#define IOCTL_REMOVE_PROCESS \
CTL_CODE(FILE_DEVICE_UNKNOWN, 0x882, METHOD_NEITHER , FILE_READ_DATA)


NTSTATUS
HandleQueryVersion(
	PVOID,
	PVOID,
	ULONG,
	ULONG
);

NTSTATUS
HandleFinish(
	PVOID,
	PVOID,
	ULONG,
	ULONG
);

NTSTATUS
HandleAddProcess(
	PVOID,
	PVOID,
	ULONG,
	ULONG
);

NTSTATUS
HandleRemoveProcess(
	PVOID,
	PVOID,
	ULONG,
	ULONG
);

#endif


